<?php

namespace Modules\Cotacao\Modules\AnaliseCotacoes\Services;

use Doctrine\ORM\EntityManager;

class Sup04000ProdutoNaoCotadoService extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    public function __constructor($crudService) {
        $this->crudService = $crudService;
    }
    
    public function getUnlistedProduct($row, $launchUnit) {
        try {
            $params = array (
                array(
                    "columnName" => "P_CDFILIALSOLI",
                    "operator" => "=",
                    "value" => implode("_", $row["CDFILSOLI"])
                ),
                array(
                    "columnName" => "P_CDFILIAL",
                    "operator" => "=",
                    "value" => empty($row["CDFILLANCA"]) ? $launchUnit : implode("_", $row["CDFILLANCA"])
                ),
                array(
                    "columnName" => "P_CDREGIAO",
                    "operator" => "=",
                    "value" => empty($row["CDREGIAO"]) ? "T" : implode("_", $row["CDREGIAO"])
                ),
                array(
                    "columnName" => "P_CDCOMPRADOR",
                    "operator" => "=",
                    "value" => empty($row["CDOPERADOR"]) ? "T" : implode("_", $row["CDOPERADOR"])
                ),
                array(
                    "columnName" => "P_DTINICIAL",
                    "operator" => "=",
                    "value" => $row["DT_ENTREGA"]["start"]
                ),
                array(
                    "columnName" => "P_DTFINAL",
                    "operator" => "=",
                    "value" => $row["DT_ENTREGA"]["end"]
                ),
                array(
                    "columnName" => "P_DTINICOT",
                    "operator" => "=",
                    "value" => $row["DT_VALIDADE"]["start"]
                ),
                array(
                    "columnName" => "P_DTFINCOT",
                    "operator" => "=",
                    "value" => $row["DT_VALIDADE"]["end"]
                ),
                array(
                    "columnName" => "P_CDARVPRODINI",
                    "operator" => "=",
                    "value" => $row["CDPRODINI"]
                ),
                array(
                    "columnName" => "P_CDARVPRODFIN",
                    "operator" => "=",
                    "value" => str_pad($row["CDPRODFIN"], 20, "z", STR_PAD_RIGHT)
                ),
            );
            
            $dataset = $this->crudService->getFilteredDataSet("getUnlistedProduct", $params)->getRows();
            asort($dataset);
            $dataset = $this->removeSemicolon($dataset);
            
            return $dataset;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function removeSemicolon($dataset) {
        for ($i = 0; $i < count($dataset); $i++) {
            $dataset[$i]["DESCPARTIC"] = str_replace("; ", "", $dataset[$i]["DESCPARTIC"]);   
        }
        
        return $dataset;
    }
}